unit cars;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ComObj, StdVcl,
  CorbaObj, CarCounerServer_TLB;

type

  TCarCounter = class(TCorbaImplementation, ICarCounter)
  private
    { Private declarations }
    Count : Integer;
  public
    { Public declarations }
  protected
    function Get_Count: Integer; safecall;
    procedure Clear; safecall;
    procedure Inc; safecall;
  end;

implementation

uses CorbInit;

function TCarCounter.Get_Count: Integer;
begin
  Result := Count;
end;

procedure TCarCounter.Clear;
begin
  Count := 0;
end;

procedure TCarCounter.Inc;
begin
  Count := Count + 1;
end;

initialization
  TCorbaObjectFactory.Create('CarCounterFactory', 'CarCounter', 'IDL:CarCounerServer/CarCounterFactory:1.0', ICarCounter,
    TCarCounter, iSingleInstance, tmSingleThread);
end.